/// <reference types="supertest" />
import { IMidwayApplication } from '@midwayjs/core';
import { ApiFunction, InternalConfig } from '@midwayjs/hooks-core';
export declare function createAppImplementation(baseDir: string, isFunction: boolean): Promise<HooksApplication>;
export declare function createApp(baseDir?: string): Promise<HooksApplication>;
export declare function createFunctionApp(baseDir?: string): Promise<HooksApplication>;
export declare class HooksApplication {
    private readonly app;
    private config;
    constructor(app: IMidwayApplication<any>, config: InternalConfig);
    runFunction<T extends ApiFunction>(fn: T, ...args: Parameters<T>): Promise<ReturnType<T>>;
    request<T extends ApiFunction>(fn: T, ...args: Parameters<T>): import("supertest").Test;
    close(): Promise<void>;
}
